﻿namespace LogExportProvider
{
    using System;

    public interface ILoggerService
    {
        bool IsVerboseEnabled
        {
            get;
        }

        bool IsDebugEnabled
        {
            get;
        }

        bool IsInfoEnabled
        {
            get;
        }

        bool IsWarnEnabled
        {
            get;
        }

        bool IsErrorEnabled
        {
            get;
        }

        bool IsPerfEnabled
        {
            get;
        }

        void Verbose(string message);

        void Verbose(string message, Exception exception);

        void Verbose(string message, params object[] args);

        void Debug(string message);

        void Debug(string message, Exception exception);

        void Debug(string message, params object[] args);

        void Info(string message);

        void Info(string message, Exception exception);

        void Info(string message, params object[] args);

        void Warn(string message);

        void Warn(string message, Exception exception);

        void Warn(string message, params object[] args);

        void Error(string message);

        void Error(string message, Exception exception);

        void Error(string message, params object[] args);

        IDisposable Perf(string message);

        IDisposable Perf(string message, params object[] args);
    }
}